﻿local IM = InterruptManager
local IMversion = IM.GetVersion()
IM.DropDown = {}

function IM.OpenConfig()
    if not InterruptManagerConfig then
        IM.CreateConfig()
        InterruptManagerConfig:Show()
        else
        InterruptManagerConfig:Show()
    end
    InterruptManagerAnchor:Show()
    InterruptManagerAnchor:SetHeight(IMDB.anchorSize[2])
    for i=1,5 do
        getglobal("InterruptManagerStatusBar"..i):Show()
        getglobal("InterruptManagerIcon"..i):Show()
        if (IMDB.interrupters[i].name ~= "") then
            getglobal("InterruptManagerConfigEditbox"..i):SetText(IMDB.interrupters[i].name)
        end
    end
    SendAddonMessage("InterruptManager","Version"..IMversion,"RAID")
end

function IM.CreateConfig()
    -- Configuration box
    local f = CreateFrame("Frame","InterruptManagerConfig")
    f:SetHeight(490)
    f:SetWidth(300)
    f:SetPoint("CENTER")
    f:SetParent(UIParent)
    f:SetFrameLevel(1)
    f:SetMovable(1)
    f:SetBackdrop({
        bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background",
        edgeFile = "Interface\\AddOns\\InterruptManager\\Textures\\ConfigBorder",
        tile = true,
        tileSize = 16,
        edgeSize = 16,
        insets = {left = 5,right = 5,top = 5,bottom = 5}
    })
    
    -- Configuration box title
    f = CreateFrame("Frame")
    f:SetHeight(30)
    f:SetWidth(200)
    f:SetPoint("CENTER","InterruptManagerConfig","TOP",0,-15)
    f:SetParent(InterruptManagerConfig)
    f:SetScript("OnMouseDown",function()InterruptManagerConfig:StartMoving()end)
    f:SetScript("OnMouseUp",function()InterruptManagerConfig:StopMovingOrSizing()end)
    f:SetBackdrop({
        bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background",
        edgeFile = "Interface\\AddOns\\InterruptManager\\Textures\\ConfigBorder",
        tile = true,
        tileSize = 16,
        edgeSize = 16,
        insets = {left = 5,right = 5,top = 5,bottom = 5}
    })
    local t = f:CreateFontString()
    t:SetPoint("CENTER",f,"CENTER",0,0)
    t:SetFont("Fonts\\FRIZQT__.TTF",12)
    t:SetText("Interrupt Manager")
    
    local moveAll = 30
    -- Close button
    IM.CreateConfigButton("Close",80,0,-245+moveAll,IM.OnCloseClick)
    -- Reset button
    IM.CreateConfigButton("Reset",80,0,0+moveAll,IM.Reset)
    -- Editboxes
    IM.CreateConfigEditbox("First Interrupter",0,150+moveAll)
    IM.CreateConfigEditbox("Second Interrupter",0,120+moveAll)
    IM.CreateConfigEditbox("Third Interrupter",0,90+moveAll)
    IM.CreateConfigEditbox("Fourth Interrupter",0,60+moveAll)
    IM.CreateConfigEditbox("Fifth Interrupter",0,30+moveAll)
    -- Fill in name buttons
    IM.CreateConfigButton("1",20,-115,150+moveAll,function() IM.FillInName(1) end)
    IM.CreateConfigButton("2",20,-115,120+moveAll,function() IM.FillInName(2) end)
    IM.CreateConfigButton("3",20,-115,90+moveAll,function() IM.FillInName(3) end)
    IM.CreateConfigButton("4",20,-115,60+moveAll,function() IM.FillInName(4) end)
    IM.CreateConfigButton("5",20,-115,30+moveAll,function() IM.FillInName(5) end)
    -- Checkboxes
    IM.CreateConfigCheckbutton("Lock bars",-80,-30+moveAll,"Turn on to lock bars",not IMDB.anchorMovable,IM.OnFrameLock)
    IM.CreateConfigCheckbutton("Solo mode",-80,-60+moveAll,"Turn on to be warned when your target/focus is casting, regardless of your position in the queue",IMDB.soloMode,IM.OnSoloModeToggle)
    IM.CreateConfigCheckbutton("Announce",-80,-90+moveAll,"Turn on to announce your interrupts",IMDB.announce,IM.OnAnnounceToggle)
    IM.CreateConfigCheckbutton("PUG mode",-80,-120+moveAll,"Turn on if someone is missing the addon",IMDB.pugMode,IM.OnPUGModeToggle)
    IM.CreateConfigCheckbutton("Watch target",-80,-150+moveAll,"Turn on to be warned when your target casts a spell",IMDB.targetWarn,IM.OnTargetWatchToggle)
    IM.CreateConfigCheckbutton("Watch focus ",-80,-180+moveAll,"Turn on to be warned when your focus casts a spell",IMDB.focusWarn,IM.OnFocusWatchToggle)
    IM.CreateConfigCheckbutton("Announce secondary spells",-80,-210+moveAll,"Turn on to announce secondary abilities (Disrupting Shout, Avenger's Shield)",IMDB.announceSecondarySpells,IM.OnSecondarySpellToggle)
    -- DropDown menus (x, y, script, text)
    IM.CreateConfigDropDown(80, -61, IM.AnnounceDropDown, IMDB.announceChannel)
    IM.CreateConfigDropDown(80, -91, IM.PugModeDropDown, IMDB.pugModeChannel)
    InterruptManagerConfig:Hide()
end

function IM.OnSecondarySpellToggle()
    local a = not IMDB.announceSecondarySpells
    IMDB.announceSecondarySpells = a
    
    if (a) then
        ChatFrame1:AddMessage("InterruptManager: Secondary spell announcement enabled.",1,0.5,0)
    else
        ChatFrame1:AddMessage("InterruptManager: Secondary spell announcement disabled.",1,0.5,0)
    end
end

function IM.PugModeDropDown()
    local function OnClick(self, arg1)
        IMDB.pugModeChannel = arg1
        UIDropDownMenu_SetText(InterruptManagerConfigDropDown2, arg1)
    end
    
    local info = UIDropDownMenu_CreateInfo()
    local c = IMDB.pugModeChannel
    
    info.func = OnClick
    
    info.text, info.checked, info.arg1 = "SAY", c == "SAY", "SAY"
    UIDropDownMenu_AddButton(info)
    
    info.text, info.checked, info.arg1 = "YELL", c == "YELL", "YELL"
    UIDropDownMenu_AddButton(info)
    
    info.text, info.checked, info.arg1 = "PARTY", c == "PARTY", "PARTY"
    UIDropDownMenu_AddButton(info)
    
    info.text, info.checked, info.arg1 = "RAID", c == "RAID", "RAID"
    UIDropDownMenu_AddButton(info)
    
    info.text, info.checked, info.arg1 = "RAID_WARNING", c == "RAID_WARNING", "RAID_WARNING"
    UIDropDownMenu_AddButton(info)
    
    info.text, info.checked, info.arg1 = "WHISPER", c == "WHISPER", "WHISPER"
    UIDropDownMenu_AddButton(info)
end

function IM.AnnounceDropDown()
    local function OnClick(self, arg1)
        IMDB.announceChannel = arg1
        UIDropDownMenu_SetText(InterruptManagerConfigDropDown1, arg1)
    end
    
    local info = UIDropDownMenu_CreateInfo()
    local c = IMDB.announceChannel
    
    info.func = OnClick
    
    info.text, info.checked, info.arg1 = "SAY", c == "SAY", "SAY"
    UIDropDownMenu_AddButton(info)
    
    info.text, info.checked, info.arg1 = "YELL", c == "YELL", "YELL"
    UIDropDownMenu_AddButton(info)
    
    info.text, info.checked, info.arg1 = "PARTY", c == "PARTY", "PARTY"
    UIDropDownMenu_AddButton(info)
    
    info.text, info.checked, info.arg1 = "RAID", c == "RAID", "RAID"
    UIDropDownMenu_AddButton(info)
    
    info.text, info.checked, info.arg1 = "RAID_WARNING", c == "RAID_WARNING", "RAID_WARNING"
    UIDropDownMenu_AddButton(info)
end

function IM.CreateConfigDropDown(x, y, script, text)
    for i=1,100 do
        if (not _G["InterruptManagerConfigDropDown"..i]) then
            local f = CreateFrame("Frame", "InterruptManagerConfigDropDown"..i, InterruptManagerConfig, "UIDropDownMenuTemplate")
            f:SetPoint("CENTER", "InterruptManagerConfig", "CENTER", x, y)
            UIDropDownMenu_SetWidth(f, 80)
            UIDropDownMenu_Initialize(f, script)
            UIDropDownMenu_SetText(f, text)
            break
        end
    end
end

function IM.CreateConfigCheckbutton(text,x,y,tooltip,checked,script)
    if (checked) then checked = 1 else checked = 0 end
    for i=1,100 do
        if not getglobal("InterruptManagerConfigCheckbutton"..i) then
            f = CreateFrame("CheckButton","InterruptManagerConfigCheckbutton"..i,InterruptManagerConfig,"ChatConfigCheckButtonTemplate")
            f:SetSize(20,20)
            f:SetPoint("CENTER","InterruptManagerConfig","CENTER",x,y)
            f:SetFrameLevel(2)
            f:SetScript("OnClick",script)
            f:SetChecked(checked)
            f:SetNormalTexture("Interface\\AddOns\\InterruptManager\\Textures\\ConfigCheckboxUp")
            f:SetPushedTexture("Interface\\AddOns\\InterruptManager\\Textures\\ConfigCheckboxDown")
            f:SetHighlightTexture("Interface\\AddOns\\InterruptManager\\Textures\\ConfigButtonHighlight",0)
            f:SetCheckedTexture("Interface\\AddOns\\InterruptManager\\Textures\\ConfigCheckboxChecked")
            f:SetDisabledTexture("Interface\\AddOns\\InterruptManager\\Textures\\ConfigButtonDisabled")
            f.tooltip = tooltip
            t = f:CreateFontString("InterruptManagerConfigCheckButton"..i.."Text")
            t:SetPoint("LEFT","InterruptManagerConfigCheckbutton"..i,"LEFT",25,0)
            t:SetFont("Fonts\\FRIZQT__.TTF",12)
            t:SetText(text)
            break
        end
    end
end

function IM.CreateConfigEditbox(text,x,y)
    for i=1,100 do
        if not getglobal("InterruptManagerConfigEditbox"..i) then
            f = CreateFrame("Editbox","InterruptManagerConfigEditbox"..i)
            f:SetSize(200,30)
            f:SetParent(InterruptManagerConfig)
            f:SetPoint("CENTER","InterruptManagerConfig","CENTER",x,y)
            f:SetFrameLevel(2)
            f:SetBackdrop({
                bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background",
                edgeFile = "Interface\\AddOns\\InterruptManager\\Textures\\ConfigBorder",
                tile = true,
                tileSize = 16,
                edgeSize = 16,
                insets = {left = 5,right = 5,top = 5,bottom = 5}
            })
            f:SetAutoFocus(false)
            f:ClearFocus()
            f:SetFont("Fonts\\FRIZQT__.TTF",12)
            f:Insert(text)
            f:SetMaxLetters(50)
            f:SetTextInsets(9,0,0,0)
            f:SetScript("OnEscapePressed",function()getglobal("InterruptManagerConfigEditbox"..i):ClearFocus()end)
            f:SetScript("OnEnterPressed",function()getglobal("InterruptManagerConfigEditbox"..i):ClearFocus()end)
            f:SetScript("OnTabPressed",IM.EditboxOnTabPressed)
            f:SetScript("OnEditFocusGained",function()getglobal("InterruptManagerConfigEditbox"..i):HighlightText()end)
            f:SetScript("OnEditFocusLost",function()getglobal("InterruptManagerConfigEditbox"..i):HighlightText(0,0)end)
            break
        end
    end
end

function IM.EditboxOnTabPressed()
    for i=1,5 do
        f = getglobal("InterruptManagerConfigEditbox"..i)
        if f then
            if f:HasFocus() then
                if i < 5 then
                    getglobal("InterruptManagerConfigEditbox"..i+1):SetFocus()
                    break
                    else
                    InterruptManagerConfigEditbox1:SetFocus()
                    break
                end
            end
        end
    end
end

function IM.CreateConfigButton(text,width,x,y,script,tooltip)
    for i=1,100 do
        if not getglobal("InterruptManagerConfigButton"..i) then
            f = CreateFrame("Button","InterruptManagerConfigButton"..i)
            f:SetScript("OnClick",script)
            f:SetHeight(20)
            f:SetWidth(width)
            f:SetParent(InterruptManagerConfig)
            f:SetPoint("CENTER","InterruptManagerConfig","CENTER",x,y)
            f:SetFrameLevel(2)
            f:SetNormalTexture("Interface\\AddOns\\InterruptManager\\Textures\\ConfigButtonUp")
            f:SetPushedTexture("Interface\\AddOns\\InterruptManager\\Textures\\ConfigButtonDown")
            f:SetHighlightTexture("Interface\\AddOns\\InterruptManager\\Textures\\ConfigButtonHighlight",0)
            f:SetDisabledTexture("Interface\\AddOns\\InterruptManager\\Textures\\ConfigButtonDisabled")
            f.tooltip = tooltip
            
            local font = f:CreateFontString()
            f:SetFontString(font)
            f:SetPushedTextOffset(-1,-1)
            font:SetFont("Fonts\\FRIZQT__.TTF",12)
            font:SetText(text)
            font:SetTextColor(0,0,0)
            break
        end
    end
end

function IM.FillInName(i)
    if UnitExists("target") then
        _G["InterruptManagerConfigEditbox"..i]:SetText(IM.GetUnitName("target"))
    end
end

function IM.GetUnitName(unit)
    if (UnitExists(unit)) then
        local name, realm = UnitName(unit)
        
        if (realm and realm ~= "") then
            return name .. "-" .. realm
        else
            return name
        end
    else
        return "no " .. unit
    end
end

function IM.OnLogin()
    local db = IMDB.interrupters
    
    InterruptManagerAnchor:Hide()
    for i=1,5 do
        if db and db[i].active then
            getglobal("InterruptManagerStatusBar"..i):Show()
            getglobal("InterruptManagerIcon"..i):Show()
            InterruptManagerAnchor:Show()
            InterruptManagerAnchor:SetHeight(IMDB.anchorSize[2]*i*0.2)
        else
            getglobal("InterruptManagerStatusBar"..i):Hide()
            getglobal("InterruptManagerIcon"..i):Hide()
        end
    end
end

function IM.Reset()
    InterruptManagerConfigEditbox1:SetText("First Interrupter")
    InterruptManagerConfigEditbox2:SetText("Second Interrupter")
    InterruptManagerConfigEditbox3:SetText("Third Interrupter")
    InterruptManagerConfigEditbox4:SetText("Fourth Interrupter")
    InterruptManagerConfigEditbox5:SetText("Fifth Interrupter")
    
    for i=1,5 do
        getglobal("InterruptManagerStatusBarText"..i):SetText("")
        getglobal("InterruptManagerStatusBar"..i):SetPoint("LEFT",getglobal("InterruptManagerIcon"..i),"RIGHT")
        getglobal("InterruptManagerStatusBar"..i):SetValue(0)
        
        IMDB.interrupters[i] = {}
        IMDB.interrupters[i].active = false
        IMDB.interrupters[i].spells = {["active"] = false}
        IMDB.interrupters[i].name = ""
        IMDB.interrupters[i].ready = false
        IMDB.interrupters[i].next = false
    end
end

function IM.OnFrameLock()
    if IMDB.anchorMovable then
        IMDB.anchorMovable = not IMDB.anchorMovable
        ChatFrame1:AddMessage("InterruptManager: Frame locked.",1,0.5,0)
        InterruptManagerConfigCheckbutton1:SetChecked(1)
        InterruptManagerAnchor:SetMovable(false)
        InterruptManagerAnchor:EnableMouse(false)
        InterruptManagerAnchor:SetScript("OnMouseDown",nil)
        InterruptManagerAnchor:SetScript("OnMouseUp",nil)
    else
        IMDB.anchorMovable = not IMDB.anchorMovable
        InterruptManagerConfigCheckbutton1:SetChecked(0)
        ChatFrame1:AddMessage("InterruptManager: Frame unlocked.",1,0.5,0)
        InterruptManagerAnchor:SetMovable(true)
        InterruptManagerAnchor:EnableMouse(true)
        InterruptManagerAnchor:SetScript("OnMouseDown",function()InterruptManagerAnchor:StartMoving()end)
        InterruptManagerAnchor:SetScript("OnMouseUp",IM.SavePosition)
    end
end

function IM.OnSoloModeToggle()
    if (not IMDB.soloMode) then
        IMDB.soloMode = not IMDB.soloMode
        ChatFrame1:AddMessage("InterruptManager: Solo mode enabled. You will now be warned when your target/focus starts casting a spell, regardless of your position in the queue.",1,0.5,0)
    else
        IMDB.soloMode = not IMDB.soloMode
        ChatFrame1:AddMessage("InterruptManager: Solo mode disabled.",1,0.5,0)
    end
end

function IM.OnAnnounceToggle()
    if (not IMDB.announce) then
        IMDB.announce = not IMDB.announce
        ChatFrame1:AddMessage("InterruptManager: Announce enabled.",1,0.5,0)
    else
        IMDB.announce = not IMDB.announce
        ChatFrame1:AddMessage("InterruptManager: Announce disabled.",1,0.5,0)
    end
end

function IM.OnPUGModeToggle()
    if (not IMDB.pugMode) then
        IMDB.pugMode = not IMDB.pugMode
        ChatFrame1:AddMessage("InterruptManager: PUG mode enabled. You will now announce when someone uses their interrupt ability, and whose turn it is next. This option is disabled when logging in.",1,0.5,0)
        SendAddonMessage("InterruptManager","pugmode:true","RAID")
    else
        IMDB.pugMode = not IMDB.pugMode
        ChatFrame1:AddMessage("InterruptManager: PUG mode disabled.",1,0.5,0)
        --SendAddonMessage("InterruptManager","pugmode:false","RAID")
    end
end

function IM.OnTargetWatchToggle()
    if (not IMDB.targetWarn) then
        IMDB.targetWarn = not IMDB.targetWarn
        ChatFrame1:AddMessage("InterruptManager: You will now be warned when your target starts casting a spell.",1,0.5,0)
    else
        IMDB.targetWarn = not IMDB.targetWarn
        ChatFrame1:AddMessage("InterruptManager: You will no longer be warned when your target starts casting a spell.",1,0.5,0)
    end
end

function IM.OnFocusWatchToggle()
    if (not IMDB.focusWarn) then
        IMDB.focusWarn = not IMDB.focusWarn
        ChatFrame1:AddMessage("InterruptManager: You will now be warned when your focus starts casting a spell.",1,0.5,0)
    else
        IMDB.focusWarn = not IMDB.focusWarn
        ChatFrame1:AddMessage("InterruptManager: You will no longer be warned when your focus starts casting a spell.",1,0.5,0)
    end
end

IM.warnOnce = true
function IM.BroadcastInterrupters()
    local msg = "rotationinfo:"
    
    for i = 1,5 do
        local text = _G["InterruptManagerConfigEditbox"..i]:GetText()
        local missing = true
        
        if (text ~= "" and not strfind(text, "Interrupter")) then
            if (i > 1) then
                msg = msg .. ","
            end
            msg = msg.._G["InterruptManagerConfigEditbox"..i]:GetText()
        end
        
        if (IsInRaid()) then
            for i = 1,40 do
                if (IM.GetUnitName("raid"..i) == text) then
                    missing = false
                end
            end        
        elseif (IsInGroup()) then
            for i = 1,4 do
                if (IM.GetUnitName("party"..i) == text) then
                    missing = false
                end
            end
        end
        if (text == "") then missing = false end
        if (text == "First Interrupter" or text == "Second Interrupter" or text == "Third Interrupter" or text == "Fourth Interrupter" or text == "Fifth Interrupter") then missing = false end
        if (text == UnitName("player")) then missing = false end
        
        if (missing and IM.warnOnce) then
            ChatFrame1:AddMessage("Warning: " .. text .. " is missing from the group. InterruptManager will not work as intended unless you click close while all rotation members are in your group.",1,0.5,0)
            IM.warnOnce = false
        elseif (missing) then
            DEFAULT_CHAT_FRAME:AddMessage("Warning: " .. text .. " is missing from the group.")
        end
    end
    
    SendAddonMessage("InterruptManager", msg, "RAID")
    SendAddonMessage("InterruptManager", "versioninfo:" .. IMversion, "RAID")
end

function IM.AddInterrupter(text, i)
    local db = IMDB.interrupters
    
    db[i].active = true
    db[i].name = text
    db[i].ready = true
    db[i].pos = i
    db[i].readyTime = i
    if (i == 1) then db[i].next = true else db[i].next = false end
    
    IM.UpdateInterruptRotation()
end

function IM.SetNameToPosition(name, pos)
    local db = IMDB.interrupters
    
    for k,v in pairs(db) do
        if (v.name == name) then
            _G["InterruptManagerStatusBar"..k]:SetPoint("LEFT", _G["InterruptManagerIcon"..pos], "RIGHT")
        end
    end
end

function IM.UpdateBars()
    -- Reset stuff
    if not InterruptManagerConfig then IM.CreateConfig() end
    for i=1,5 do
        IMDB.interrupters[i] = {}
        IMDB.interrupters[i].active = false
        IMDB.interrupters[i].spells = {}
        IMDB.interrupters[i].name = ""
        IMDB.interrupters[i].ready = false
        IMDB.interrupters[i].next = false
    end
    
    local db = IMDB.interrupters
    
    IMDB.numInterrupters = 0
    for i = 1,5 do
        local text = _G["InterruptManagerConfigEditbox"..i]:GetText()
        
        if (text ~= "" and not strfind(text, " Interrupter")) then
            IM.AddInterrupter(text, i)
            IMDB.numInterrupters = IMDB.numInterrupters + 1
        end
    end
    
    InterruptManagerAnchor:SetHeight(0)
    
    for i=1,5 do
        _G["InterruptManagerStatusBar"..i]:SetPoint("LEFT", _G["InterruptManagerIcon"..i], "RIGHT")
        _G["InterruptManagerStatusBar"..i]:SetValue(0)
        _G["InterruptManagerSecondaryStatusBar"..i]:SetValue(0)
        InterruptManagerAnchor:Hide()
        _G["InterruptManagerStatusBar"..i]:Hide()
        _G["InterruptManagerIcon"..i]:Hide()
    end
    
    for i=1,5 do
        local text = _G["InterruptManagerConfigEditbox"..i]:GetText()
        if text ~= "" and not strfind(text, " Interrupter") then
            InterruptManagerAnchor:SetHeight(0.2*i*IMDB.anchorSize[2])
            InterruptManagerAnchor:Show()
            _G["InterruptManagerStatusBar"..i]:Show()
            _G["InterruptManagerIcon"..i]:Show()
        end
    end
end

function IM.OnCloseClick()
    InterruptManagerConfig:Hide()
    IM.UpdateBars()
    IMDB.leader = true
    
    if (IsInGroup() or IsInRaid()) then
        IM.BroadcastInterrupters()
    end
end

function IM.ReceiveRotationInfo(msg)
    -- Message example
    -- playername[,playername][,playername][,playername][,playername]
    local db = IMDB.interrupters
    
    -- Don't procceed unless player's name is in the message
    if not strfind(msg, UnitName("player")) then return end
    
    IMDB.leader = false
    
    if (not InterruptManagerConfig) then
        IM.CreateConfig()
    end
    
    for i = 1,5 do
        if (msg ~= "") then
            local temp = strfind(msg, ",")
            local name
            
            if (not temp and msg) then
                name = msg
                msg = gsub(msg, name, "")
            elseif (msg) then
                name = strsub(msg, 1, temp-1)
                msg = gsub(msg, name .. ",", "")
            end
            
            _G["InterruptManagerConfigEditbox"..i]:SetText(name)
        else
            _G["InterruptManagerConfigEditbox"..i]:SetText("")
        end
    end
    
    SendAddonMessage("InterruptManager", "versioninfo:" .. IMversion, "RAID")
    IM.UpdateBars()
end

function IM.ReceiveSpellInfo(spell, sender)
    -- Message example
    -- spellid
    local db = IMDB.interrupters
    
    for i = 1,5 do
        if (sender == db.name) then
            db.spells[tonumber(spell)] = GetTime()
        end
    end
end

function IM.ReceiveVersionInfo(msg)
    local otherVersion = msg
    local myVersion = IMversion
    
    if (tonumber(otherVersion) > tonumber(myVersion)) then
        ChatFrame1:AddMessage("InterruptManager: An update is available for InterruptManager.",1,0.5,0)
    end
end

function IM.ReceivePugModeInfo(msg)
    if (msg == "true") then
        InterruptManagerConfigCheckbutton4:SetChecked(false)
        IMDB.pugMode = false
    end
end

-- Requests information about interrupters' cooldowns after (re)logging or reloading ui
function IM.ReceiveGetInfoRequest(msg)
    --if (not IMDB.leader) then return end
    
    local sender = msg
    msg = "takeinfo:"
    
    local db = IMDB.interrupters
    
    for i = 1,IMDB.numInterrupters do
        msg = msg .. db[i].readyTime .. ","
    end
    
    SendAddonMessage("InterruptManager", msg, "WHISPER", sender)
end

-- Function to read in the data sent in response to the login-triggered data request
function IM.ReceiveGetInfoRequestResponse(msg)
    local db = IMDB.interrupters
    
    for i = 1,IMDB.numInterrupters do
        _G["InterruptManagerStatusBar"..i]:SetMinMaxValues(0,20)
        local readyTime = strsub(msg, 1, strfind(msg, ",")-1)
        msg = gsub(msg, readyTime .. ",", "", 1)
        
        db[i].readyTime = tonumber(readyTime)
    end
    
    IM.UpdateInterruptRotation()
end

function IM.ReceiveCooldownAdjustInfo(msg, sender)
    local db = IMDB.interrupters
    
    local spellId = tonumber(strsub(msg, 1, strfind(msg, ",")-1))
    msg = gsub(msg, spellId .. ",", "", 1)
    
    local readyTime = tonumber(strsub(msg, 1, strfind(msg, ",")-1))
    
    for i = 1,IMDB.numInterrupters do
        if (strfind(sender, db[i].name)) then
            db[i].spells[spellId] = readyTime
        end
    end
end

IM.addonMessages =
{
{"rotationinfo:", IM.ReceiveRotationInfo},
{"versioninfo:", IM.ReceiveVersionInfo},
{"pugmode:", IM.ReceivePugModeInfo},
{"getinfo:", IM.ReceiveGetInfoRequest},
{"takeinfo:", IM.ReceiveGetInfoRequestResponse},
{"cd:", IM.ReceiveCooldownAdjustInfo},
}

function IM.AddonMessageReceived(...)
    local msg, _, sender = select(2, ...)
    if (strfind(sender, UnitName("player"))) then return end
    
    for k,v in pairs(IM.addonMessages) do
        local key = v[1]
        local func = v[2]
        
        if (strfind(msg, key)) then
            msg = gsub(msg, key, "")
            func(msg, sender)
        end
    end
end

function round(num,dec)
    return string.format("%." .. dec .. "f", tostring(num))
end